var map;
var infowindows = [];
var markers = [];
var jsonArr;
var curMarker;
var curLocation;

function initmap(lat,lng) {
   var mapOptions = {
      zoom: 16,
      scaleControl: false,
      center: new google.maps.LatLng(lat,lng),
      zoomControl: false,
      streetViewControl: false,
      mapTypeId: google.maps.MapTypeId.ROADMAP
   };
   map = new google.maps.Map(document.getElementById("map_canvas"),
                             mapOptions);

   google.maps.event.addListener(map, 'click', function() {
      closeInfoWindows();
   });
   jsObject.show();
 //  show();
}
function showmap(jsondata) {
   clearAll();
   jsonArr = eval(jsondata);
   if (jsonArr.length > 0) {
      //console.log("setbounds");
      //setBounds();
      setInfoWindows();
      setMarkers();
      //setTimeout(showFirstInfoWindow, 500);
   }
}

function setBounds() {
   if (jsonArr.length > 0) {
      var bounds = new google.maps.LatLngBounds();
      for (var i = 0; i < jsonArr.length; i++) {
         var lat = jsonArr[i].lat;
         var lng = jsonArr[i].lng;
         var latlng = new google.maps.LatLng(lat, lng);
         bounds = bounds.extend(latlng);
      }

      if (typeof bounds != 'undefined') {
         map.fitBounds(bounds);
      }
   }
}

function attachInfoToMarker(marker, index) {
   google.maps.event.addListener(marker, 'click', function() {
      var lat = jsonArr[index].lat;
      var lng = jsonArr[index].lng;
      var latlng = new google.maps.LatLng(lat, lng);
      map.panTo(latlng);
      closeInfoWindows();
      infowindows[index].open(map, marker);
   });
}

function setMarkers() {
   for (var i = 0; i < jsonArr.length; i++) {
      var lat = jsonArr[i].lat;
      var lng = jsonArr[i].lng;
      var index = jsonArr[i].index;
      var name = jsonArr[i].name;
      var image = jsonArr[i].category;
      image = image + ".png";
      var position = new google.maps.LatLng(lat, lng);
      var pinIcon = new google.maps.MarkerImage(
         image,
         null, /* size is determined at runtime */
         null, /* origin is 0,0 */
         new google.maps.Point(18, 42), /* anchor is bottom center of the scaled image */
         new google.maps.Size(36, 48)
      );
      markers[i] = new google.maps.Marker({
         title: name,
         position: position,
         map: map,
         icon: pinIcon
      });
      attachInfoToMarker(markers[i], index);
   }
}

function setInfoWindows() {
   for (var i = 0; i < jsonArr.length; i++) {
      var infowindow = new InfoBubble({
         map: map,
         content: getInfoCotent(i),
         position: new google.maps.LatLng(jsonArr[i].lat, jsonArr[i].lng),
         shadowStyle: 1,
         padding: 12,
         backgroundColor: 'rgb(255,255,255)',
         borderRadius: 4,
         arrowSize: 8,
         borderWidth: 0,
         maxHeight: 144,
         minHeight: 40,
         disableAutoPan: true,
         hideCloseButton: true,
         arrowPosition: 50,
         backgroundClassName: 'phoney',
         arrowStyle: 0
      });
      infowindows.push(infowindow);
   }
}

function panToPosition(lat, lng) {
   map.panTo(new google.maps.LatLng(lat, lng));
}

function showFirstInfoWindow() {
   if (jsonArr.length > 0) {
      var lat = jsonArr[0].lat;
      var lng = jsonArr[0].lng;
      var latlng = new google.maps.LatLng(lat, lng);
   //   map.panTo(latlng);
      infowindows[0].open(map, markers[0]);
   }
}

function closeInfoWindows() {
   for (var i = 0; i < infowindows.length; i++) {
      var infowindow = infowindows[i];
      infowindow.close();
   }
}

function showCurLocation(lat, lng) {
   if (typeof map != 'undefined') {
      if (typeof curMarker != 'undefined') {
         curMarker.setMap(null);
      }
      var pinIcon = new google.maps.MarkerImage(
         "my_location.png",
         null, /* size is determined at runtime */
         null, /* origin is 0,0 */
         null, /* anchor is bottom center of the scaled image */
         new google.maps.Size(16, 16)
      );
      curLocation = new google.maps.LatLng(lat, lng);
      curMarker = new google.maps.Marker({
         position: curLocation,
         map: map,
         icon: pinIcon
      });
   }

}

function focusCurLocation() {
   if (typeof curLocation != 'undefined') {
      map.panTo(curLocation);
   }
}

function getInfoCotent(index) {
   var divContent = '<div id="content"';
   if (index > 0) {
      divContent += 'onclick="javascript:jsObject.detail(' + index + ');"'
   }
   var image = jsonArr[index].image;
   if (image == undefined || image.length <= 0)
      image = "category/" + jsonArr[index].category + "_rec.png";
   divContent += '"> <div class="left_container"><img src="'+ image + '"></img>';

   divContent += '</div> ';
   divContent += '<div class = "center_container"> ';
   divContent += '<div class = "name"> ' + jsonArr[index].name + '</div>';

   var star = '<span class="cfb-stars cfb-stars0' + jsonArr[index].rating + '">';
   star += '<span class="cfb-stars-inner"></span>';
   star += '</span>';
   divContent += star;

   var str = '<div class = "country"> ';
   if (jsonArr[index].city != undefined && jsonArr[index].city.length > 0) {
      str += jsonArr[index].city + " ";
   }
   if (jsonArr[index].country != undefined && jsonArr[index].country.length > 0) {
      str += jsonArr[index].country;
   }
   if (jsonArr[index].distance != undefined && jsonArr[index].distance.length > 0) {
      str += ", " + jsonArr[index].distance;
   }
   str += '</div> ';
   divContent += str + "</div> ";
   divContent += '<div class = "right_container"> <img src = "arrow.png" width="18" height="18"></img></div>';
   divContent += '</div> ';
   return divContent;
}

function show() {
   var json = [{
      "category": "more",
      "name": "青浦",
      "name_en": "qingpu",
      "lat": 31.15,
      "lng": 121.1,
      "index": 0,
      "rating": 0,
      "distance": "10m",
      "image": "http://img.chufaba.me/usercover_B68E7E66-1442-49DB-AC90-BBA868249B0B.jpg!320",
      "city": "香港",
      "country": "中国"
   }, {
      "category": "more",
      "name": "崇明",
      "name_en": "chongming",
      "lat": 31.73,
      "lng": 121.4,
      "rating": 3,
      "index": 1,
      "distance": "10m",
      "image": "http://img.chufaba.me/usercover_EBE2AC6E-C833-4907-8B7E-2C34F90D1904.jpg!320",
      "city": "香港",
      "country": "中国"
   }, {
      "category": "sight",
      "name": "松江",
      "name_en": "songjiang",
      "lat": 31.00,
      "lng": 121.24,
      "rating": 4,
      "index": 2,
      "distance": "10m",
      "image": "http://img.chufaba.me/routes/2014/04/19/fda8dcf89b91f405.jpg!320",
      "city": "香港",
      "country": "中国"
   }];
   showmap(json);
}

function clearAll () {
   clearInfoWindows();
   clearMarkers();
}

function clearInfoWindows() {
   for (var i = 0; i < infowindows.length; i++) {
      infowindows[i].setMap(null);
   }
   infowindows = [];
}

function clearMarkers() {
   for (var i = 0; i < markers.length; i++) {
      markers[i].setMap(null);
   }
   markers = [];
}

